#[doc = "Register `VS2` reader"]
pub struct R(crate::R<VS2_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<VS2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<VS2_SPEC>> for R {
    fn from(reader: crate::R<VS2_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `VS2` writer"]
pub struct W(crate::W<VS2_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<VS2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<VS2_SPEC>> for W {
    fn from(writer: crate::W<VS2_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `VS_TOP` reader - RAM configuration for TOP DSI vertical segmentation, not implemented in BOTTOM DSI blocks"]
pub struct VS_TOP_R(crate::FieldReader<u8, u8>);
impl VS_TOP_R {
    pub(crate) fn new(bits: u8) -> Self {
        VS_TOP_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for VS_TOP_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `VS_TOP` writer - RAM configuration for TOP DSI vertical segmentation, not implemented in BOTTOM DSI blocks"]
pub struct VS_TOP_W<'a> {
    w: &'a mut W,
}
impl<'a> VS_TOP_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | (value as u16 & 0x0f);
        self.w
    }
}
#[doc = "Field `VS_BOT` reader - RAM configuration for BOTTOM DSI vertical segmentation, not implemented in TOP DSI blocks"]
pub struct VS_BOT_R(crate::FieldReader<u8, u8>);
impl VS_BOT_R {
    pub(crate) fn new(bits: u8) -> Self {
        VS_BOT_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for VS_BOT_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `VS_BOT` writer - RAM configuration for BOTTOM DSI vertical segmentation, not implemented in TOP DSI blocks"]
pub struct VS_BOT_W<'a> {
    w: &'a mut W,
}
impl<'a> VS_BOT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 4)) | ((value as u16 & 0x0f) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - RAM configuration for TOP DSI vertical segmentation, not implemented in BOTTOM DSI blocks"]
    #[inline(always)]
    pub fn vs_top(&self) -> VS_TOP_R {
        VS_TOP_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:7 - RAM configuration for BOTTOM DSI vertical segmentation, not implemented in TOP DSI blocks"]
    #[inline(always)]
    pub fn vs_bot(&self) -> VS_BOT_R {
        VS_BOT_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - RAM configuration for TOP DSI vertical segmentation, not implemented in BOTTOM DSI blocks"]
    #[inline(always)]
    pub fn vs_top(&mut self) -> VS_TOP_W {
        VS_TOP_W { w: self }
    }
    #[doc = "Bits 4:7 - RAM configuration for BOTTOM DSI vertical segmentation, not implemented in TOP DSI blocks"]
    #[inline(always)]
    pub fn vs_bot(&mut self) -> VS_BOT_W {
        VS_BOT_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "DSI VS Tile Configuration; Vertical Segmentation\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [vs2](index.html) module"]
pub struct VS2_SPEC;
impl crate::RegisterSpec for VS2_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [vs2::R](R) reader structure"]
impl crate::Readable for VS2_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [vs2::W](W) writer structure"]
impl crate::Writable for VS2_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets VS2 to value 0"]
impl crate::Resettable for VS2_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
